import org.junit.jupiter.api.Test;
import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.Arguments;
import org.junit.jupiter.params.provider.MethodSource;

import java.util.*;
import java.util.stream.IntStream;
import java.util.stream.Stream;

import static org.junit.jupiter.api.Assertions.*;

class Aufgabe2Test {
    private static final List<int[]> inputs = new ArrayList<>();

    static {
        Random rand = new Random(4711);
        while (inputs.size() < 100) {
            int length = rand.nextInt(100);
            if (length > 0) {
                int[] arr = new int[length];
                for (int i = 0; i < arr.length; i++) {
                    arr[i] = rand.nextInt(100) - 50;
                }
                inputs.add(arr);
            }
        }
    }

    private static Stream<Arguments> getTestInputArrays() {
        return inputs.stream().map(Arguments::of);
    }

    @ParameterizedTest
    @MethodSource("getTestInputArrays")
    void getMin(int[] arr) {
        if (arr.length > 0) {
            assertEquals(Arrays.stream(arr).min().getAsInt(), Aufgabe2.getMin(arr));
        }
    }

    @ParameterizedTest
    @MethodSource("getTestInputArrays")
    void printArray(int[] arr) {
        assertEquals(Arrays.toString(arr), Aufgabe2.printArray(arr));
    }

    @Test
    void printArrayEmpty() {
        assertEquals("[]", Aufgabe2.printArray(new int[]{}));
    }

    private static Stream<Arguments> getTestInputNumbers() {
        return IntStream.range(0, 50).mapToObj(Arguments::of);
    }

    @ParameterizedTest
    @MethodSource("getTestInputNumbers")
    void mul(int n) {
        int[] result = Aufgabe2.mul(n);
        assertEquals(n, result.length, "Das zurückgegebene Array hat die falsche Länge!");
        for (int i = 0; i < n; i++) {
            assertEquals(i*n - i*i - i, result[i], "Falscher Wert an Position " + i);
        }
    }
}
