import org.junit.jupiter.params.ParameterizedTest;
import org.junit.jupiter.params.provider.ValueSource;

import java.util.stream.IntStream;

import static org.junit.jupiter.api.Assertions.*;

class Aufgabe3Test {
    private final Integer[] divisors = new Integer[1000];

    Aufgabe3Test() {
        for (int i = 2; i < divisors.length; i++) {
            final int j = i; // Variable used in lambda expression should be final
            divisors[i] = IntStream.range(2, i - 1)
                    .filter(k -> j % k == 0)
                    .mapToObj(k -> (Integer) k)
                    .findAny()
                    .orElse(null);
        }
    }

    @ParameterizedTest
    @ValueSource(ints = {5, 7, 20, 33, 50, 74, 111, 256, 65, 750, 999})
    void sieb(int n) {
        boolean[] result = Aufgabe3.sieb(n);
        assertEquals(n + 1, result.length, "Das zurückgegebene Array hat die falsche Länge!");
        for (int i = 2; i < result.length; i++) {
            if (divisors[i] == null) {
                assertTrue(
                        result[i],
                        "Ergebnis für Zahl " + i + " ist falsch!"
                );
            } else {
                assertFalse(
                        result[i],
                        "Ergebnis für Zahl " + i + " ist falsch!"
                                + " (Keine Primzahl, weil teilbar durch " + divisors[i] + ")"
                );
            }
        }
    }
}
